<?php

require_once dirname( __FILE__ ) . '/lib/xmlrpc.inc';
require_once dirname( __FILE__ ) . '/Blogger.php';
require_once dirname( __FILE__ ) . '/MetaWebLogAPI.php';
require_once dirname( __FILE__ ) . '/plurk/plurk_api.php';
require_once dirname( __FILE__ ) . '/friendfeed.php';

class Web2 {

	public function __construct() {

	}

	public function PostMetaWebLog( $domain, $endpoint, $blog_id, $username, $password, $title, $content ) {
		$meta = new MetaWebLogAPI( $domain, $endpoint, $blog_id, $username, $password );
		$meta->Post( $title, $content );
	}

	public function PostWordpress( $username, $password, $prefix, $title, $content ) {
		$this->PostMetaWebLog( "$prefix.wordpress.com", '/xmlrpc.php', 1, $username, $password, $title, $content );
	}

	public function PostXanga( $username, $password, $title, $content ) {
		$this->PostMetaWebLog( 'api.xanga.com', '/metaweblogapi', 1, $username, $password, $title, $content );
	}

	public function PostPublr( $username, $password, $title, $content ) {
		$this->PostMetaWebLog( 'publr.com', '/metaweblog/', null, $username, $password, $title, $content );
	}

	public function PostTypePad( $username, $password, $blog_id, $title, $content ) {
		$this->PostMetaWebLog( 'www.typepad.com', '/t/api', $blog_id, $username, $password, $title, $content );
	}

	public function PostBlogger( $username, $password, $id, $title, $content ) {
		$blogger = new Blogger( $username, $password, $id );
		$blogger->createPost( $title, $content, False );
	}

  public function PostPosterous( $posterous_email, $posterous_password, $title, $content ) {
    $url = 'http://posterous.com/api/newpost';

    $request_data = http_build_query(
     array(
      'title' => $title,
      'body' => $content
     )
    );

    $c = curl_init( $url );
    curl_setopt($c, CURLOPT_HTTPAUTH, CURLAUTH_BASIC ) ;
    curl_setopt($c, CURLOPT_USERPWD, $posterous_email . ':' . $posterous_password);
    curl_setopt($c, CURLOPT_POST, true);
    curl_setopt($c, CURLOPT_POSTFIELDS, $request_data);
    curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
    $result = curl_exec($c);
    $status = curl_getinfo($c, CURLINFO_HTTP_CODE);
    curl_close($c);

    if ($status == 200) {
      return true;
    }

    return false;
   }

	public function PostLiveJournal( $username, $password, $title, $content ) {
		$req = new xmlrpcmsg( 'LJ.XMLRPC.postevent' );

		$struct = new xmlrpcval( array(
			'username' => new xmlrpcval( $username, 'string' ),
			'password' => new xmlrpcval( $password, 'string' ),
			'event' => new xmlrpcval( $content, 'string' ),
			'subject' => new xmlrpcval( $title, 'string' ),
			'lineendings' => new xmlrpcval( 'pc', 'string' ),
			'year' => new xmlrpcval( date( 'Y' ), 'int' ),
			'mon' => new xmlrpcval( date( 'n' ), 'int' ),
			'day' => new xmlrpcval( date( 'j' ), 'int' ),
			'hour' => new xmlrpcval( date( 'G' ), 'int'),
			'min' => new xmlrpcval( date( 'i' ), 'int' )
		), 'struct' );

		$req->addParam( $struct );

		$cl = new xmlrpc_client( '/interface/xmlrpc', 'livejournal.com', 80, 'http11' );
    $cl->request_charset_encoding = 'utf-8';
		$cl->send( $req );
	}

	public function PostTumblr( $email, $password, $title, $content ) {
		// Prepare POST request
		$request_data = http_build_query(
		    array(
		        'email'     => $email,
		        'password'  => $password,
		        'type'      => 'regular',
		        'title'     => $title,
		        'body'      => $content,
		        'generator' => 'API'
		    )
		);

		// Send the POST request (with cURL)
		$c = curl_init('http://www.tumblr.com/api/write');
		curl_setopt($c, CURLOPT_POST, true);
		curl_setopt($c, CURLOPT_POSTFIELDS, $request_data);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		$result = hijack_curl_exec($c);
	}

	public function PostMultiply( $username, $password, $title, $content ) {
		$url = "http://$username.multiply.com/api/post";

		$request_data = http_build_query(
			array(
				'api_key' => '2JiSmbK',
				'password' => $password,
				'type' => 'journal',
				'subject' => $title,
				'body' => $content
			)
		);

		$c = curl_init( $url );
		curl_setopt($c, CURLOPT_POST, true);
		curl_setopt($c, CURLOPT_POSTFIELDS, $request_data);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		$result = hijack_curl_exec($c);
	}

	public function PostPlurk( $username, $password, $api_key, $plurk ) {
		$plurk_api = new plurk_api();
		$plurk_api->login( $api_key, $username, $password );
		$plurk_api->add_plurk( 'en', 'says', $plurk );
	}

	public function PostFriendFeed( $username, $remote_key, $title, $link='' ) {
		$friendfeed = new FriendFeed( $username, $remote_key );
    	$entry = $friendfeed->publish_link( $title, $link );
	}

	public function PostIdentica( $status, $username, $password ) {
		$method = 'POST';
		$endpoint = '/statuses/update.json';
		$params = array( 'status' => $status );

	    $url = 'http://identi.ca/api' . $endpoint;
	    $ch  = curl_init($url);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);
	    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query( $params ) );
	    if(!empty($username) && !empty($password))
	      curl_setopt($ch, CURLOPT_USERPWD, "{$username}:{$password}");

	    hijack_curl_exec( $ch );
	}

	public function TestMetaWebLog( $domain, $endpoint, $blog_id, $username, $password ) {
		$meta = new MetaWebLogAPI( $domain, $endpoint, $blog_id, $username, $password );
		return $meta->Test();
	}

	public function TestWordpress( $username, $password, $prefix ) {
		return $this->TestMetaWebLog( "$prefix.wordpress.com", '/xmlrpc.php', null, $username, $password );
	}

	public function TestPublr( $username, $password ) {
		$meta = new MetaWebLogAPI( 'publr.com', '/api/xmlrpc', null, $username, $password );
		return $meta->TestPublr();
	}

	public function TestTypepad( $username, $password, $blog_id ) {
		$meta = new MetaWebLogAPI( "www.typepad.com", '/t/api', $blog_id, $username, $password );
		return $meta->TestGetPosts();
	}

	public function TestBlogger( $username, $password ) {
		try {
			$blogger = new Blogger( $username, $password );
			return true;
		} catch ( Exception $ex ) {
			return false;
		}
	}

	public function TestLiveJournal ( $username, $password ) {
		$req = new xmlrpcmsg( 'LJ.XMLRPC.login' );

		$struct = new xmlrpcval( array(
			'username' => new xmlrpcval( $username, 'string' ),
			'password' => new xmlrpcval( $password, 'string' ),
		), 'struct' );

		$req->addParam( $struct );

		$cl = new xmlrpc_client( '/interface/xmlrpc', 'livejournal.com', 80, 'http11' );
		$ans = $cl->send( $req );

		try {
			if ( $ans->val == false ) {
				return false;
			}

			return true;
		} catch ( Exception $ex ) {
			return false;
		}
	}

	public function TestPosterous ( $username, $password ) {
    $url = 'http://posterous.com/api/getsites';

    $c = curl_init( $url );
    curl_setopt($c, CURLOPT_HTTPAUTH, CURLAUTH_BASIC ) ;
    curl_setopt($c, CURLOPT_USERPWD, $username . ':' . $password);
    curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
    $result = curl_exec($c);
    $status = curl_getinfo($c, CURLINFO_HTTP_CODE);
    curl_close($c);

    if ($status == 200) {
      return true;
    }

    return false;
	}

	public function TestMultiply( $username, $password ) {
		$url = "http://$username.multiply.com/api/read";

		$request_data = http_build_query(
			array(
				'api_key' => '2JiSmbK',
				'password' => $password,
				'type' => 'journal'
			)
		);

		$c = curl_init( $url );
		curl_setopt($c, CURLOPT_POST, true);
		curl_setopt($c, CURLOPT_POSTFIELDS, $request_data);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($c);
		$status = curl_getinfo($c, CURLINFO_HTTP_CODE);

		if ( $status == 200 ) {
			return true;
		}

		return false;
	}

	public function TestPlurk( $username, $password, $api_key ) {
		$plurk_api = new plurk_api();
		return $plurk_api->login( $api_key, $username, $password );
	}

	public function TestFriendFeed( $username, $apikey ) {
		$friendfeed = new FriendFeed( $username, $apikey );
    	$feed = $friendfeed->fetch_home_feed();

    	if ( $feed ) {
    		return true;
    	}

    	return false;
	}

	public function TestXanga( $username, $password ) {
		$meta = new MetaWebLogAPI( 'api.xanga.com', '/metaweblogapi', 1, $username, $password );
		return $meta->TestGetPosts();
	}

	public function TestIdentica( $username, $password ) {
		$method = 'POST';
		$endpoint = '/account/verify_credentials.json';

	    $url = 'http://identi.ca/api' . $endpoint;
	    $ch  = curl_init($url);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);

	    if(!empty($username) && !empty($password))
	      curl_setopt($ch, CURLOPT_USERPWD, "{$username}:{$password}");

	    $resp = curl_exec( $ch );
	    $status = curl_getinfo($ch, CURLINFO_HTTP_CODE);

	    return $status == 200;
	}

	public function TestBitly( $login, $key ) {
		$url = "http://api.bit.ly/v3/validate?x_login=notbilytapi&x_apiKey=not_apikey&login=$login&apiKey=$key";

		$c = curl_init( $url );
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		$json_text = curl_exec($c);
		$json = json_decode( $json_text );
		curl_close($c);

		if ( $json->status_code == 200 ) {
			return true;
		}

		return false;
	}

	public function TestTumblr( $username, $password ) {
		// Prepare POST request
		$request_data = http_build_query(
		    array(
		        'email'     => $username,
		        'password'  => $password
		    )
		);

		// Send the POST request (with cURL)
		$c = curl_init('http://www.tumblr.com/api/authenticate');
		curl_setopt($c, CURLOPT_POST, true);
		curl_setopt($c, CURLOPT_POSTFIELDS, $request_data);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($c);
		$status = curl_getinfo($c, CURLINFO_HTTP_CODE);
		curl_close($c);

		if ( $result == 'Invalid credentials.' ) {
			return false;
		}

		return true;
	}

	public function GetBloggerBlogs( $username, $password ) {
		try {
			$blogger = new Blogger( $username, $password );
			return $blogger->getBlogs();
		} catch ( Exception $ex ) {
			return false;
		}
	}

}

?>
