<?php

require_once dirname( __FILE__ ) . '/wpalBox.php';

class wpalConfigBox extends wpalBox {

  protected $config;
  protected $save;

  public function __construct( $title, $config, $save = false ) {
    parent::__construct( $title, array( $this, 'RenderContent' ) );
    $this->config = $config;
    $this->save = $save;
  }

  protected function RenderContent() {
    echo '<table class="form-table" style="width: 100%;" cellspacing="2" cellpadding="5">';

    foreach ( $this->config as $label => $details ) {
      $hint = '';

      if ( is_array( $details ) && isset( $details[ 'type' ] ) ) {
        $type = $details[ 'type' ];
        $name = $details[ 'name' ];

        if ( $type !== 'test' ) {
          if ( isset( $details[ 'hint' ] ) ) $hint = $details[ 'hint' ];
          if ( isset( $details[ 'password' ] ) && $details[ 'password' ] ) $type = 'Password';
          $value = $details[ 'value' ];
        }
        else {
          $value = $details[ 'args' ];
        }
      } else {
        $type = 'text';
        $name = $details;
        $value = '';
      }

      call_user_func_array( array( 'wpalBox', 'Render' . $type . 'Option' ), array(
        $label, $name, $value, $hint
      ));
    }

    echo '</table>';
  }

}

