<?php

class wpalPage {

  protected $title;
  protected $content_boxes;
  protected $form = null;

  public function __construct( $title ) {
    $this->title = "WPSyndicator &mdash; $title";
    $this->content_boxes = array();
  }

  public function AddContentBox( $cb ) {
    $this->content_boxes[] = $cb;
  }

  public function AddForm( $action, $method, $hidden = null ) {
    $this->form = array(
      'action' => $action,
      'method' => $method,
      'hidden' => $hidden
    );
  }

  public function Render() { ?>
    <script type="text/javascript">
    //<![CDATA[
      jQuery( function() {
        jQuery( '#poststuff .inner-sidebar' )
          .keep_in_view( 20 )
          .append_sidebar_ad( 'wpsyndicator' );
      } );
    //]]>
    </script>

    <div class="wrap">
      <div id="icon-plugins" class="icon32"><br /></div>
      <h2><?php echo $this->title; ?></h2>
      <div id="poststuff" class="metabox-holder has-right-sidebar">
        <?php if ( $this->form ) { ?>
          <form action="<?php echo $this->form[ 'action' ]; ?>" method="<?php echo $this->form[ 'method' ]; ?>">
          <?php if ( $this->form[ 'hidden' ] ) { ?>
            <input type="hidden" name="<?php echo $this->form[ 'hidden' ]; ?>" />
          <?php } ?>
        <?php } ?>

        <div class="inner-sidebar">

          <?php if ( $this->form ) : ?>
            <div class="stuffbox">
              <h3>Save</h3>
              <div class="submitbox">
                <div id="major-publishing-actions">
                  <div id="publishing-action">
                    <input type="submit" class="button-primary" value="Save Settings" />
                  </div>
                  <div class="clear"></div>
                </div>
              </div>
            </div>
          <?php endif; ?>

          <div class="stuffbox">
            <h3>Help</h3>
            <div class="submitbox">
              <div class="inside">
                <p><a href="http://www.wpsyndicator.com/manual" target="_blank">
                  Download the WPSyndicator manual</a></p>
                <p><a href="mailto:support@wpsyndicator.com">
                  Email our support team</a></p>
              </div>
            </div>
          </div>

        </div>

        <div id="post-body">
          <div id="post-body-content">
            <?php foreach ( $this->content_boxes as $box ) $box->render(); ?>
          </div>
        </div>

        <?php if ( $this->form ) { ?>
          </form>
        <?php } ?>
      </div>
    </div>
  <?php }

}
